*=============================================================================
* TSBrowse.ch  Version 1.0 1/Sep/2005
* Creating Browse From Code
*=============================================================================
#xcommand @ <row>,<col> TBROWSE <name>         ;
        [ID <nId>] ;
        [ <dummy1: OF, PARENT, DIALOG> <parent> ] ;
        [ WIDTH <w> ]             ;
        [ HEIGHT <h> ]             ;
        [ <head: HEAD,HEADER,HEADERS> <aHeaders,...> ] ;
        [ <sizes: WIDTHS, FIELDSIZES, SIZES, COLSIZES> <aColSizes,...> ] ;
        [ <alias: ALIAS, ITEMS, ARRAY, WORKAREA> <uAlias> ]    ;
        [ FIELDS <Fields,...> ] ;
        [ SELECTFILTER <cField> FOR <uValue1> [ TO <uValue2> ] ] ;
        [ <enum: ENUMERATOR> ] ;
        [ <autosearch: AUTOSEARCH>  [ USERSEARCH <uUserSearch> ] ];
        [ <autofilter: AUTOFILTER>  [ USERFILTER <uUserFilter> ] ];
        [ VALUE <value> ]           ;
        [ FONT <fontname> ]         ;
        [ SIZE <fontsize> ]         ;
        [ <bold : BOLD> ]           ;
        [ <italic : ITALIC> ]       ;
        [ <underline : UNDERLINE> ] ;
        [ <strikeout : STRIKEOUT> ] ;
        [ TOOLTIP <tooltip> ]       ;
        [ BACKCOLOR <backcolor> ]   ;
        [ FONTCOLOR <fontcolor> ] ;
        [ <color: COLOR, COLORS> <aColors,...> ] ;
        [ ON GOTFOCUS <gotfocus> ]     ;
        [ ON CHANGE <uChange> ]        ;
        [ ON LOSTFOCUS <lostfocus> ]   ;
        [ ON DBLCLICK <uLDblClick> ]   ;
        [ <edit : EDIT> ]              ;
        [ <cell: CELL, CELLED, GRID> ] ;
        [ STYLE <nStyle> ]             ;
        [ <append : APPEND> ]          ;
        [ ON HEADCLICK <aHeadClick> ]  ;
        [ WHEN <uWhen> ]               ;
        [ VALID <aValidFields> ]       ;
        [ VALIDMESSAGES <aValidMessages> ] ;
        [ MESSAGE <cMsg> ]             ;
        [ READONLY <aReadOnly> ]       ;
        [ <lock: LOCK> ]               ;
        [ <Delete: DELETE> ]           ;
        [ <style: NOLINES> ]           ;
        [ IMAGE <aImages,...> ]        ;
        [ JUSTIFY <aJust> ]            ;
        [ HELPID <helpid> ]            ;
        [ <break: BREAK> ]             ;
    =>;
<name> :=_DefineTBrowse (<"name"> ,    ;
        <"parent"> ,     ;
       [ <col> ],        ;
       [ <row> ],        ;
       [ <w> ],         ;
       [ <h> ],         ;
       [ \{<aHeaders>\}] , ;
       [ \{<aColSizes>\}], ;
       [  \{|| \{ <Fields> \} \} ], ;
       [ <(cField)>], [<uValue1>], [<uValue2> ], ;
       [ <value> ],        ;
       [ <fontname> ],     ;
       [ <fontsize> ],     ;
       [ <tooltip> ],      ;
       [ <{uChange}> ],    ;
       [ \{|nRow,nCol,nFlags|<uLDblClick>\} ], ;
       [ <aHeadClick> ],   ;
       [ <{gotfocus}> ],   ;
       [ <{lostfocus}> ],  ;
       [ <uAlias> ],       ;
       [ <.Delete.> ],     ;
       [ <.style.> ],      ;
       [  \{<aImages>\} ], ;
       [ <aJust> ], ;
       [ <helpid> ], ;
       [ <.bold.> ], ;
       [ <.italic.> ], ;
       [ <.underline.> ], ;
       [ <.strikeout.> ], ;
       [ <.break.> ] , ;
       [ <backcolor> ], ;
       [ <fontcolor> ], ;
       [ <.lock.>  ], ;
       [ <.cell.> ], ;
       [ <nStyle> ], ;
       [ <.append.> ], ;
       [ <aReadOnly> ], ;
       [ <{aValidFields}> ], ;
       [ <aValidMessages> ], ;
       [ <.edit.> ], ;
       [ \{<aColors>\} ], ;
       [ <{uWhen}> ],[ <nId> ],[\{<(Fields)>\}],[<cMsg>], .t. ,;
       [ <.enum.> ],[ <.autosearch.> ],[ <{uUserSearch}> ],;
       [ <.autofilter.> ], [ <{uUserFilter}> ])

#xcommand DEFINE TBROWSE <name>         ;
        AT <row>,<col> ;
        [ID <nId>] ;
        [ <dummy1: OF, PARENT, DIALOG> <parent> ] ;
        [ WIDTH <w> ]             ;
        [ HEIGHT <h> ]             ;
        [ <head: HEAD,HEADER,HEADERS> <aHeaders,...> ] ;
        [ <sizes: WIDTHS, FIELDSIZES, SIZES, COLSIZES> <aColSizes,...> ] ;
        [ <alias: ALIAS, ITEMS, ARRAY, WORKAREA> <uAlias> ]    ;
        [ FIELDS <Fields,...> ] ;
        [ SELECTFILTER <cField> FOR <uValue1> [ TO <uValue2> ] ] ;
        [ <enum: ENUMERATOR> ] ;
        [ <autosearch: AUTOSEARCH> [ USERSEARCH <uUserSearch> ] ];
        [ <autofilter: AUTOFILTER> [ USERFILTER <uUserFilter> ] ];
        [ VALUE <value> ]         ;
        [ FONT <fontname> ]         ;
        [ SIZE <fontsize> ]         ;
        [ <bold : BOLD> ] ;
        [ <italic : ITALIC> ] ;
        [ <underline : UNDERLINE> ] ;
        [ <strikeout : STRIKEOUT> ] ;
        [ TOOLTIP <tooltip> ]          ;
        [ BACKCOLOR <backcolor> ] ;
        [ FONTCOLOR <fontcolor> ] ;
        [ <color: COLOR, COLORS> <aColors,...> ] ;
        [ ON GOTFOCUS <gotfocus> ]     ;
        [ ON CHANGE <uChange> ]      ;
        [ ON LOSTFOCUS <lostfocus> ]     ;
        [ ON DBLCLICK <uLDblClick> ]      ;
        [ <edit : EDIT> ]         ;
        [ <cell: CELL, CELLED, GRID> ]        ;
        [ STYLE <nStyle> ]             ;
        [ <append : APPEND> ]         ;
        [ ON HEADCLICK <aHeadClick> ]     ;
        [ WHEN <uWhen> ]        ;
        [ VALID <aValidFields> ]    ;
        [ VALIDMESSAGES <aValidMessages> ] ;
        [ MESSAGE <cMsg> ] ;
        [ READONLY <aReadOnly> ]     ;
        [ <lock: LOCK> ]         ;
        [ <Delete: DELETE> ]        ;
        [ <style: NOLINES> ]         ;
        [ IMAGE <aImages,...> ]         ;
        [ JUSTIFY <aJust> ]         ;
        [ HELPID <helpid> ]         ;
        [ <break: BREAK> ]         ;
    =>;
<name> :=_DefineTBrowse (<"name"> ,     ;
        <"parent"> ,     ;
       [ <col> ],        ;
       [ <row> ],        ;
       [ <w> ],         ;
       [ <h> ],         ;
       [ \{<aHeaders>\}] ,     ;
       [ \{<aColSizes>\}]  ,     ;
       [  \{|| \{ <Fields> \} \} ], ;
       [ <(cField)>], [<uValue1>], [<uValue2> ], ;
       [ <value> ],    ;
       [ <fontname> ],     ;
       [ <fontsize> ],     ;
       [ <tooltip> ],     ;
       [ <{uChange}> ], ;
       [ \{|nRow,nCol,nFlags|<uLDblClick>\} ], ;
       [ <aHeadClick> ],  ;
       [ <{gotfocus}> ],    ;
       [ <{lostfocus}> ],     ;
       [ <uAlias> ],    ;
       [ <.Delete.> ],      ;
       [ <.style.> ],    ;
       [  \{<aImages>\} ],    ;
       [ <aJust> ], ;
       [ <helpid> ] , ;
       [ <.bold.> ], ;
       [ <.italic.> ], ;
       [ <.underline.> ], ;
       [ <.strikeout.> ], ;
       [ <.break.> ] , ;
       [ <backcolor> ], ;
       [ <fontcolor> ], ;
       [ <.lock.>  ], ;
       [ <.cell.> ], ;
       [ <nStyle> ], ;
       [ <.append.> ], ;
       [ <aReadOnly> ], ;
       [ <{aValidFields}> ], ;
       [ <aValidMessages> ], ;
       [ <.edit.> ],;
       [ \{<aColors>\} ], ;
       [ <{uWhen}> ],[ <nId> ],[\{<(Fields)>\}],[<cMsg>], .f. ,;
       [ <.enum.> ],[ <.autosearch.> ],[ <{uUserSearch}> ],;
       [ <.autofilter.> ], [ <{uUserFilter}> ])


#command END TBROWSE ;
   =>;
_EndTBrowse ()


*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Defining Column Objects ( General Data )
*=============================================================================

#command DEFINE COLUMN <oCol> ;
             [ <dat: DATA, SHOWBLOCK> <uData> ] ;
             [ <tit: TITLE, HEADER> <cHead> [ <oem: OEM, ANSI, CONVERT>] ];
             [ <foot: FOOT,FOOTER,FOOTERS> <cFoot> [ <oem2: OEM, ANSI, CONVERT>] ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ <align: ALIGN, ALIN> <aAlign,...> ] ;
             [ <wid: WIDTH, SIZE> <nWidth> [ PIXELS ] ] ;
             [ PICTURE <cPicture> ] ;
             [ <bit: BITMAP, CHECK, CHECKBOX, COMBO, COMBOBOX> ] ;
             [ <edit: EDITABLE> ] ;
             [ VALID <uValid> ] ;
             [ <lite: NOBAR, NOHILITE> ] ;
             [ <idx: ORDER, INDEX, TAG> <cOrder> ] ;
             [ <pre: PRE EDIT, PREEDIT> <bPrevBlock> ] ;
             [ <pst: POST EDIT,POSTEDIT> <bPostBlock> ] ;
             [ <mov: MOVE, SHIFT> <nMoveDir> ] ;
             [ <cur: DBLCURSOR, DOUBLE CURSOR, FIXED> ] ;
             [ <l3D: LOOK3D, 3DLOOK> <a3DLook,...> ] ;
             [ WHEN <uWhen> ] ;
       => ;
   <oCol> := TSColumn():New( ;
             [ If(<.oem.>, OemToAnsi(<cHead>), <cHead>) ], ;
             [ If( ValType(<uData>)=="B", <uData>, <{uData}> ) ], ;
             [ <cPicture> ], [ \{<aColors>\} ], [ \{<aAlign>\} ], ;
             [ <nWidth> ], [ Upper(<(bit)>) ], [ <.edit.> ], ;
             [ \{|uVar,This| <uValid> \}], ;
             [ <.lite.> ], [ <(cOrder)> ], ;
             [ If(<.oem2.>, OemToAnsi(<cFoot>), <cFoot>) ], ;
             [ <{bPrevBlock}> ], [ <{bPostBlock}> ], [ <nMoveDir> ], ;
             [ <.cur.> ], [ \{<a3DLook>\} ], [ <{uWhen}> ],, <(uData)>, ;
             [ <(uWhen)> ], [<(uValid)>], [<(bPrevBlock)>], [<(bPostBlock)>]  )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Adding Column to Browse( General Data )
*=============================================================================

#command ADD [ COLUMN ] TO [ TBROWSE ] <oBrw> ;
             [ <dat: DATA, SHOWBLOCK> <uData> ] ;
             [ <tit: TITLE, HEADER> <cHead> [ <oem: OEM, ANSI, CONVERT>] ] ;
             [ <foot: FOOT,FOOTER,FOOTERS> <cFoot> [ <oem2: OEM, ANSI, CONVERT>] ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ <align: ALIGN, ALIGNS> <aAlign,...> ] ;
             [ <wid: WIDTH, SIZE> <nWidth> [ PIXELS ] ] ;
             [ PICTURE <cPicture> ] ;
             [ <bit: BITMAP, CHECK, CHECKBOX, COMBO, COMBOBOX> ] ;
             [ <edit: EDITABLE> ] ;
             [ VALID <uValid> ] ;
             [ <lite: NOBAR, NOHILITE> ] ;
             [ <idx: ORDER, INDEX, TAG> <cOrder> ] ;
             [ <pre: PRE EDIT, PREEDIT> <bPrevBlock> ] ;
             [ <pst: POST EDIT,POSTEDIT> <bPostBlock> ] ;
             [ <mov: MOVE, SHIFT> <nMoveDir> ] ;
             [ <cur: DBLCURSOR, DOUBLE CURSOR, FIXED> ] ;
             [ <look3d: LOOK3D, 3DLOOK> <a3DLook,...> ] ;
             [ WHEN <uWhen> ] ;
       => ;
    <oBrw>:AddColumn( TSColumn():New( ;
             [ If(<.oem.>, OemToAnsi(<cHead>), <cHead>) ], ;
             [ If( ValType(<uData>)=="B", <uData>, <{uData}> ) ], ;
             [ <cPicture> ], [ \{<aColors>\} ], ;
             [ \{<aAlign>\} ], [ <nWidth> ], ;
             [ Upper(<(bit)>) ], [ <.edit.> ], ;
             [ \{|uVar,This| <uValid> \}], ;
             [ <.lite.> ], [ <(cOrder)> ], ;
             [ If(<.oem2.>, OemToAnsi(<cFoot>), <cFoot>) ], ;
             [ <{bPrevBlock}> ], [ <{bPostBlock}> ], [ <nMoveDir> ], ;
             [ <.cur.> ], [ \{<a3DLook>\} ], ;
             [ If( ValType(<uWhen>)=="B", <uWhen>, <{uWhen}> ) ], <oBrw>, ;
             <(uData)>, [<(uWhen)>], [<(uValid)>], [<(bPrevBlock)>], ;
             [<(bPostBlock)>] ) )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Adding Column to Browse ( Array Data )
*=============================================================================

#command ADD [ COLUMN ] TO [ TBROWSE ] <oBrw> [ DATA ] ARRAY ;
             [ <el: ELM, ELEMENT> <elm> ] ;
             [ <tit: TITLE, HEADER> <cHead> [ <oem: OEM, ANSI, CONVERT>] ];
             [ <foot: FOOT,FOOTER,FOOTERS> <cFoot> [ <oem2: OEM, ANSI, CONVERT>] ] ;  // <new193>  added by LKM 28/Mar/97
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ <align: ALIGN, ALIGNS> <aAlign,...> ] ;
             [ <wid: WIDTH, SIZE> <nWidth> [ PIXELS ] ] ;
             [ PICTURE <cPicture> ] ;
             [ <bit: BITMAP, CHECK, CHECKBOX, COMBO, COMBOBOX> ] ;
             [ <edit: EDITABLE> ] ;
             [ VALID <uValid> ] ;
             [ <lite: NOBAR, NOHILITE> ] ;
             [ <pre: PRE EDIT, PREEDIT> <bPrevBlock> ] ;
             [ <pst: POST EDIT,POSTEDIT> <bPostBlock> ] ;
             [ <mov: MOVE, SHIFT> <nMoveDir> ] ;
             [ <cur: DBLCURSOR, DOUBLE CURSOR, FIXED> ] ;
             [ <l3D: LOOK3D, 3DLOOK> <a3DLook,...> ] ;
             [ WHEN <uWhen> ] ;
       => ;
    <oBrw>:AddColumn( TSColumn():New( ;
             [ If(<.oem.>, OemToAnsi(<cHead>), <cHead>) ], ;
             \{|x| If(PCount() > 0, <oBrw>:aArray\[<oBrw>:nAt, <elm>\] := x, ;
                      <oBrw>:aArray\[<oBrw>:nAt, <elm>\])\}, [ <cPicture> ], ;
             [ \{<aColors>\} ], [ \{<aAlign>\} ], [ <nWidth> ], ;
             [ Upper(<(bit)>) ], [ <.edit.> ], ;
             [ \{|uVar,This| <uValid> \}], ;
             [ <.lite.> ], Nil, ;
             [ If(<.oem2.>, OemToAnsi(<cFoot>), <cFoot>) ], ;
             [ <{bPrevBlock}> ], [ <{bPostBlock}> ], [ <nMoveDir> ], ;
             [ <.cur.> ], [ \{<a3DLook>\} ], ;
             [ If( ValType(<uWhen>)=="B", <uWhen>, <{uWhen}> ) ], <oBrw>,, ;
             [<(uWhen)>], [<(uValid)>], [<(bPrevBlock)>], [<(bPostBlock)>] ) )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Adding Column to Browse ( TDataBase .and. TMultiDBF Classes Data )
*=============================================================================

#command ADD [ COLUMN ] TO [ TBROWSE ] <oBrw> [ DATA ] ;
               <fi: oDBF, FIELD> [FIELD] <field> ;
             [ ALIAS <cAlias> ] ;
             [ <tit: TITLE, HEADER> <cHead> [ <oem: OEM, ANSI, CONVERT>] ] ;
             [ <foot: FOOT,FOOTER,FOOTERS> <cFoot> [ <oem2: OEM, ANSI, CONVERT>] ] ;  // <new193>  added by LKM 28/Mar/97
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ <align: ALIGN, ALIGNS> <aAlign,...> ] ;
             [ <wid: WIDTH, SIZE> <nWidth> [ PIXELS ] ] ;
             [ PICTURE <cPicture> ] ;
             [ <bit: BITMAP, CHECK, CHECKBOX, COMBO, COMBOBOX> ] ;
             [ <edit: EDITABLE> ] ;
             [ VALID <uValid> ] ;
             [ <lite: NOBAR, NOHILITE> ] ;
             [ <idx: ORDER, INDEX, TAG> <cOrder> ] ;
             [ <pre: PRE EDIT, PREEDIT> <bPrevBlock> ] ;
             [ <pst: POST EDIT,POSTEDIT> <bPostBlock> ] ;
             [ <mov: MOVE, SHIFT> <nMoveDir> ] ;
             [ <cur: DBLCURSOR, DOUBLE CURSOR, FIXED> ] ;
             [ <l3D: LOOK3D, 3DLOOK> <a3DLook,...> ] ;
       => ;
    <oBrw>:AddColumn( TSColumn():New( ;
             [ If(<.oem.>, OemToAnsi(<cHead>), <cHead>) ], ;
               \{|x| If(PCount() > 0, <oBrw>:oDbf:[<cAlias>:]<field> := x, ;
                       <oBrw>:oDbf:[<cAlias>:]<field>) \}, [ <cPicture> ], ;
             [ \{<aColors>\} ], [ \{<aAlign>\} ], [ <nWidth> ], ;
             [ Upper(<(bit)>) ], [ <.edit.> ], [ \{|uVar,This| <uValid> \}], ;
             [ <.lite.> ], [ <(cOrder)> ], ;
             [ If(<.oem2.>, OemToAnsi(<cFoot>), <cFoot>) ] , ;
             [ <{bPrevBlock}> ], [ <{bPostBlock}> ], [ <nMoveDir> ], ;
             [ <.cur.> ], [ \{<a3DLook>\} ],, <oBrw>,,, [<(uValid)>], ;
             [ <(bPrevBlock)> ], [<(bPostBlock)>] ) )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Adding Super Headings to Browse
*=============================================================================

#command ADD [ SUPER ] HEADER TO <oBrw> ;
             FROM [ COLUMN ] <nFrom> ;
             TO [ COLUMN ] <nTo> ;
             [ <head:TITLE, HEADER> <cHead> ] ;
             [ HEIGHT <nHeight> ] ;
             [ <color:COLOR, COLORS> <aColors,...> ] ;
             [ <l3dLook: 3DLOOK, LOOK3D> ] ;
             [ FONT <uFont> ] ;
             [ <lGrid:NOGRID, NOLINES> ] ;
             [ BITMAP <uBmp> ] ;
             [ <lAdj:ADJUST> ] ;
             [ <lTra:TRANSPARENT> ] ;
             [ <horz:HORZ, HORZ ALIGN> <nHAlign> ] ;
             [ <vert:VERT, VERT ALIGN> <nVAlign> ] ;
       => ;
       <oBrw>:AddSuperHead( <nFrom>, <nTo>, <cHead>, [ <nHeight> ], ;
                            [ \{<aColors>\} ], <.l3dLook.>, <uFont>, ;
                            <uBmp>, <.lAdj.>, <.lTra.>, <.lGrid.>, ;
                            <nHAlign>, <nVAlign> )


#ifndef __NO_REDEFINE__
#define __NO_REDEFINE__
*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Predefined Constants
*=============================================================================

// Horizontal alignment
#ifndef DT_LEFT
   #define DT_LEFT              0
   #define DT_CENTER            1
   #define DT_RIGHT             2
#endif
#define DT_VERT              3  // vertical text (only for headers)
#define DT_CENTERED          DT_CENTER

// Vertical alignment
#ifndef DT_TOP
#define DT_TOP               0
#define DT_BOTTOM            2
#endif
// Cursor movement after editing
#define DT_DONT_MOVE         0
#define DT_MOVE_RIGHT        1
#define DT_MOVE_DOWN         2
#define DT_MOVE_LEFT         3
#define DT_MOVE_UP           4
#define DT_MOVE_NEXT         5

// Report method() language text selection
#define DT_DATE              1
#define DT_PAGE              2
#define DT_TIME              3
#define DT_PREVIEW           4

#define DT_SPANISH           1
#define DT_ENGLISH           2

// Flags for phantom column: with or without a grid
#define PHCOL_GRID          -1
#define PHCOL_NOGRID        -2

// Default text sizes
#define SCRL_CHARPIX_H      14
#define SCRL_CHARPIX_W       8

// Line Styles
#define LINES_NONE           0
#define LINES_ALL            1
#define LINES_VERT           2
#define LINES_HORZ           3
#define LINES_3D             4
#define LINES_DOTTED         5

// aColors items number
#define CLR_TEXT             1   // text
#define CLR_PANE             2   // back
#define CLR_HEADF            3   // header text
#define CLR_HEADB            4   // header back
#define CLR_FOCUSF           5   // focused text
#define CLR_FOCUSB           6   // focused back
#define CLR_EDITF            7   // editing text
#define CLR_EDITB            8   // editing back
#define CLR_FOOTF            9   // footer text
#define CLR_FOOTB           10   // footer back
#define CLR_SELEF           11   // focused inactive (or selected) text
#define CLR_SELEB           12   // focused inactive (or selected) back
#define CLR_ORDF            13   // order column text
#define CLR_ORDB            14   // order column back
#define CLR_LINE            15   // grid lines
#define CLR_SUPF            16   // superheader text
#define CLR_SUPB            17   // superheader back
#define CLR_SPCF            18   // specheader text
#define CLR_SPCB            19   // specheader back
#define CLR_SPCA            20   // active specheader back

// System Colors
#define COLOR_ACTIVECAPTION          2
#define COLOR_INACTIVECAPTION        3
#define COLOR_WINDOW                 5
#define COLOR_WINDOWTEXT             8
#define COLOR_CAPTIONTEXT            9
#define COLOR_HIGHLIGHT             13
#define COLOR_HIGHLIGHTTEXT         14
#define COLOR_BTNFACE               15
#define COLOR_BTNSHADOW             16
#define COLOR_BTNTEXT               18
#define COLOR_INACTCAPTEXT          19
#define COLOR_BTNHIGHLIGHT          20
#define COLOR_INFOTEXT              23
#define COLOR_INFOBK                24

// Styles
#define DS_3DLOOK                    4
#define GWL_STYLE                  -16

#define bSETGET(x) { | u | If( PCount()==0, x, x:= u ) }

#define CS_DBLCLKS                   8

#ifndef TRUE
   #define TRUE                     .T.
   #define FALSE                    .F.
#endif

//------------------------------------------------------------------------//

#translate VALID <if: IF, CONDITION> <cond> => ;
                   VALID \{|o, x| x := o:varGet(), <cond> \}

//-------------------------------------------------------------------------//

#define BN_CLICKED                 0

#define EN_SETFOCUS              256  // 0x0100
#define EN_KILLFOCUS             512  // 0x0200

#define CS_VREDRAW                 1  // 0x0001
#define CS_HREDRAW                 2  // 0x0002
#define CS_GLOBALCLASS         16384  // 0x4000

#define CS_OWNDC                  32  // 0x0020
#define CS_CLASSDC                64  // 0x0040
#define CS_PARENTDC              128  // 0x0080

#define CS_BYTEALIGNCLIENT      4096  // 0x1000
#define CS_BYTEALIGNWINDOW      8192  // 0x2000

#define WS_OVERLAPPED              0  // 0x00000000L
#define WS_POPUP          2147483648  // 0x80000000L
#define WS_CHILD          1073741824  // 0x40000000L

#define WS_CLIPSIBLINGS     67108864  // 0x04000000L
#define WS_CLIPCHILDREN     33554432  // 0x02000000L

#define WS_VISIBLE         268435456  // 0x10000000L
#define WS_DISABLED        134217728  // 0x08000000L

#define WS_MINIMIZE        536870912  // 0x20000000L
#define WS_MAXIMIZE         16777216  // 0x01000000L

#define WS_CAPTION          12582912  // 0x00C00000L
#define WS_BORDER            8388608  // 0x00800000L
#define WS_DLGFRAME          4194304  // 0x00400000L
#define WS_VSCROLL           2097152  // 0x00200000L
#define WS_HSCROLL           1048576  // 0x00100000L
#define WS_SYSMENU            524288  // 0x00080000L
#define WS_THICKFRAME         262144  // 0x00040000L
#define WS_MINIMIZEBOX        131072  // 0x00020000L
#define WS_MAXIMIZEBOX         65536  // 0x00010000L

#define WS_GROUP              131072  // 0x00020000L
#define WS_TABSTOP             65536  // 0x00010000L

#define WS_OVERLAPPEDWINDOW (WS_OVERLAPPED + WS_CAPTION + WS_SYSMENU + WS_THICKFRAME + WS_MINIMIZEBOX + WS_MAXIMIZEBOX)
#define WS_POPUPWINDOW        (WS_POPUP + WS_BORDER + WS_SYSMENU)
#define WS_CHILDWINDOW        (WS_CHILD)

#define ES_LEFT                    0
#define ES_CENTER                  1
#define ES_RIGHT                   2
#define ES_MULTILINE               4
#define ES_AUTOHSCROLL           128    // 0x0080
#define ES_READONLY             2048    // 0x0800
#define ES_WANTRETURN           4096    // 0x1000

#define WM_NULL                    0    // 0x0000
#define WM_DESTROY                 2    // 0x0002
#define WM_MOVE                    3
#define WM_SIZE                    5    // 0x0005
#define WM_SETFOCUS                7    // 0x0007
#define WM_KILLFOCUS               8    // 0x0008
#define WM_PAINT                  15    // 0x000F
#define WM_CLOSE                  16    // 0x0010
#define WM_QUERYENDSESSION        17    // 0x0011
#define WM_QUIT                   18    // 0x0012
#define WM_SYSCOLORCHANGE         21    // 0x0015
#define WM_ENDSESSION             22    // 0x0016
#define WM_SYSTEMERROR            23    // 0x0017
#define WM_WININICHANGE           26    // 0x001A
#define WM_DEVMODECHANGE          27    // 0x001B
#define WM_FONTCHANGE             29    // 0x001D
#define WM_TIMECHANGE             30    // 0x001E
#define WM_SPOOLERSTATUS          42    // 0x002A
#define WM_COMPACTING             65    // 0x0041
#define WM_NOTIFY                   78

#define WM_GETDLGCODE            135    // 0x0087
#define WM_CHAR                  258    // 0x0102
#define WM_COMMAND               273    // 0x0111
#define WM_MOUSEMOVE             512    // 0x0200
#define WM_LBUTTONDOWN           513    // 0x0201
#define WM_LBUTTONUP             514    // 0x0202
#define WM_RBUTTONDOWN           516    // 0x0204
#define WM_RBUTTONUP             517    // 0x0205
#define WM_KEYDOWN               256    // 0x0100
#define WM_KEYUP                 257    // 0x0101
#define WM_INITDIALOG            272    // 0x0110
#define WM_TIMER                 275    // 0x0113
#define WM_HSCROLL               276    // 0x0115
#define WM_VSCROLL               277    // 0x0115

#define WM_QUERYNEWPALETTE       783    // 0x030F
#define WM_PALETTEISCHANGING     784    // 0x0310
#define WM_PALETTECHANGED        785    // 0x0311

#define WM_USER                 1024    // 0x0400
#define WM_DRAWITEM               43
#define WM_ERASEBKGND             20
#define WM_ASYNCSELECT            WM_USER+1041

#define DS_SYSMODAL                2
#define DS_MODALFRAME            128  // 0x80

// Dialogs

#define DLGC_WANTARROWS                    1
#define DLGC_WANTTAB                       2
#define DLGC_WANTALLKEYS                   4
#define DLGC_WANTCHARS                   128


// ListBox Styles

#define LBS_NOTIFY               1
#define LBS_SORT                 2
#define LBS_OWNERDRAWFIXED      16  //    0x10
#define LBS_USETABSTOPS        128  //    0x80
#define LBS_NOINTEGRALHEIGHT   256  //   0x100
#define LBS_WANTKEYBOARDINPUT 1024  //   0x400
#define LBS_DISABLENOSCROLL   4096  //  0x1000
#define LBS_STANDARD      10485763  //0xA00003

// ComboBox Styles

#define CBS_SIMPLE               1  // 0x0001
#define CBS_DROPDOWN             2  // 0x0002
#define CBS_DROPDOWNLIST         3  // 0x0003
#define CBS_OWNERDRAWFIXED      16  // 0x0010
#define CBS_AUTOHSCROLL         64  // 0x0040
#define CBS_OEMCONVERT         128  // 0x0080
#define CBS_SORT               256  // 0x0100
#define CBS_DISABLENOSCROLL   2048  // 0x0800

// ScrollBar

#define SB_LINEUP                          0
#define SB_LINELEFT                        0
#define SB_LINEDOWN                        1
#define SB_LINERIGHT                       1
#define SB_PAGEUP                          2
#define SB_PAGELEFT                        2
#define SB_PAGEDOWN                        3
#define SB_PAGERIGHT                       3
#define SB_THUMBPOSITION                   4
#define SB_THUMBTRACK                      5
#define SB_TOP                             6
#define SB_LEFT                            6
#define SB_BOTTOM                          7
#define SB_RIGHT                           7
#define SB_ENDSCROLL                       8

// Scroll Bar styles

#define SBS_HORZ                           0
#define SBS_VERT                           1

// CheckBox

#define BS_PUSHBUTTON                     0
#define BS_DEFPUSHBUTTON                  1
#define BS_CHECKBOX                       2
#define BS_AUTOCHECKBOX                   3   // 0x00000003
#define BS_GROUPBOX                       7
#define BS_AUTORADIOBUTTON                9

/* Pen Styles */
#ifndef PS_SOLID
#define PS_SOLID                          0
#define PS_DASH                           1
#define PS_DOT                            2
#define PS_DASHDOT                        3
#define PS_DASHDOTDOT                     4
#define PS_NULL                           5
#define PS_INSIDEFRAME                    6
#endif

#define SS_BLACKRECT                      4
#define SS_WHITERECT                      6
#define SS_WHITEFRAME                     9
#define SS_LEFT                           0
#define SS_SIMPLE                        11   // 0x0B

#define FM_SCROLLUP    WM_USER+1025
#define FM_SCROLLDOWN  WM_USER+1026
#define FM_SCROLLPGUP  WM_USER+1027
#define FM_SCROLLPGDN  WM_USER+1028

#define FM_CHANGE      WM_USER+1029
#define FM_COLOR       WM_USER+1030
#define FM_MEASURE     WM_USER+1031
#define FM_DRAW        WM_USER+1032
#define FM_LOSTFOCUS   WM_USER+1033
#define FM_THUMBPOS    WM_USER+1034
#define FM_THUMBTRACK  WM_USER+1038

//----------------------------------------------------------------------------//
//                        Low Intensity colors
//----------------------------------------------------------------------------//

#define CLR_BLACK             0               // RGB(   0,   0,   0 )
#define CLR_BLUE        8388608               // RGB(   0,   0, 128 )
#define CLR_GREEN         32768               // RGB(   0, 128,   0 )
#define CLR_CYAN        8421376               // RGB(   0, 128, 128 )
#define CLR_RED             128               // RGB( 128,   0,   0 )
#define CLR_MAGENTA     8388736               // RGB( 128,   0, 128 )
#define CLR_BROWN         32896               // RGB( 128, 128,   0 )
#define CLR_HGRAY      12632256               // RGB( 192, 192, 192 )
#define CLR_LIGHTGRAY  CLR_HGRAY

//----------------------------------------------------------------------------//
//                       High Intensity Colors
//----------------------------------------------------------------------------//

#define CLR_GRAY        8421504               // RGB( 128, 128, 128 )
#define CLR_HBLUE      16711680               // RGB(   0,   0, 255 )
#define CLR_HGREEN        65280               // RGB(   0, 255,   0 )
#define CLR_HCYAN      16776960               // RGB(   0, 255, 255 )
#define CLR_HRED            255               // RGB( 255,   0,   0 )
#define CLR_HMAGENTA   16711935               // RGB( 255,   0, 255 )
#define CLR_YELLOW        65535               // RGB( 255, 255,   0 )
#define CLR_WHITE      16777215               // RGB( 255, 255, 255 )

#endif  // __NO_REDEFINE__
